.\" {PTM/WK/1999-11-22}
.\"	$OpenBSD: mktemp.1,v 1.5 1997/06/17 15:34:27 millert Exp $
.\"
.\" Copyright (c) 1989, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd November, 20, 1996
.Dt MKTEMP 1
.Os
.Sh NAZWA
.Nm mktemp
.Nd twrz unikaln nazw pliku tymczasowego
.Sh SKADNIA
.Nm mktemp
.Op Fl d
.Op Fl q
.Op Fl u
.Ar wzorzec
.Sh OPIS
Narzdzie
.Nm mktemp
pobiera zadany wzorzec nazwy i zastpuje jego cz by stworzy
nazw pliku. Wynikowa nazwa jest unikalna i nadaje si do uywania jako
nazwa pliku.
Wzorzec moe by
.\" ---- Nie jest prawd dla Linuksa, ale w libc z OpenBSD
.\" dowolna nazwa pliku z pewn liczb
dowoln nazw pliku z dodanymi do niej dokadnie szecioma znakami
.\" ----
.Ql X ,
na przykad
.\" .Pa /tmp/temp.XXXX .
.Pa /tmp/temp.XXXXXX .
Kocowe
.Ql X
zastpowane s przez numer biecego procesu i/lub unikaln kombinacj liter.

Liczba unikalnych nazw plikw, jakie moe zwrci
.Nm
.\" ---- Nie jest prawd dla Linuksa, ale dla libc z OpenBSD
.\" moe zwrci zaley od liczby dodanych
.\" .Ql X w;
.\" sze
.\" .Ql X w
.\" da przetestowanie okoo 26 ** 6 kombinacji.
daje okoo 26 ** 6 kombinacji.
.\" ----
.Pp
Jeli
.Nm
moe pomylnie utworzy unikaln nazw pliku, to tworzony jest plik
z prawami 0600 (chyba e podano flag
.Fl u )
za nazwa pliku wywietlana jest na standardowym wyjciu.
.Sh OPCJE
.Bl -tag -width indent
Dostpne s nastpujce opcje:
.It Fl d
Utwrz katalog zamiast pliku.
.It Fl q
Ciche zakoczenie dziaania w przypadku bdu. Przydatne, gdy skrypt nie
chce by komunikat o bdzie trafi na standardowe wyjcie bdw.
.It Fl u
Dziaaj w trybie
.Dq unsafe
(ryzykownym).
Plik tymczasowy bdzie skasowany (unlinked) przed zakoczeniem pracy
.Nm mktemp .
Jest to nieco lepsze ni
.Fn mktemp 3 ,
ale nadal wprowadza `race condition' [tum: ``wycig'' procesw
pomidzy uzyskiwaniem unikalnych nazw i nadawaniem ich plikom].
Nie zaleca si uywania tej opcji.
.Sh ZWRACANE WARTOCI
Narzdzie
.Nm
koczy prac z wartoci 0 w przypadku powodzenia, za 1 przy bdzie.
.Sh PRZYKADY
Poniszy fragment w 
.Xr sh 1
ilustruje proste zastosowanie
.Nm mktemp ,
gdzie skrypt winien zakoczy prac jeli nie moe utworzy bezpiecznego
pliku tymczasowego.
.Bd -literal -offset indent
TMPFILE=`mktemp /tmp/$0.XXXXXX` || exit 1
echo "program output" >> $TMPFILE
.Ed
.Pp
W tym przypadku chcemy, by skrypt sam obsugiwa bd.
.Bd -literal -offset indent
TMPFILE=`mktemp -q /tmp/$0.XXXXXX`
if [ $? -ne 0 ]; then
	echo "$0: Can't create temp file, exiting..."
	exit 1
fi
.Ed
.Pp
Zauwa, e mona te zamiast sprawdzania $? sprawdza,
czy $TMPFILE ma dugo zerow. Pozwala to na wykonanie
sprawdzenia w dalszej czci skryptu (gdy $? zostanie
nadpisane przez nastpne polecenie  powoki).
.Sh ZOBACZ TAKE
.Xr mkstemp 3 ,
.Xr mktemp 3 .
.Sh HISTORIA
Narzdzie
.Nm
pojawio si w
.Bx Open .
